﻿using System.Drawing;
using System.Drawing.Drawing2D;

using DevExpress.XtraEditors;
using DevExpress.XtraGrid.Views.Card;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.cardView.OptionsBehavior.AutoPopulateColumns = true;

            this.gridControl.DataSource = new nwindDataSetTableAdapters.ProductsTableAdapter().GetData();

            this.cardView.CustomDrawCardCaption += cardView_CustomDrawCardCaption;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 카드 뷰 카드 제목 커스텀 그리기 - cardView_CustomDrawCardCaption(sender, e)

        /// <summary>
        /// 카드 뷰 카드 제목 커스텀 그리기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void cardView_CustomDrawCardCaption(object sender, CardCaptionCustomDrawEventArgs e)
        {
            CardView cardView = sender as CardView;

            bool isFocused = e.RowHandle == cardView.FocusedRowHandle;

            Brush backgroundBrush;
            Brush foregroundBrush;

            Color color1 = Color.FromArgb(142, 57 , 80);
            Color color2 = Color.FromArgb(240, 140, 40);
            Color color3 = Color.FromArgb(70 , 55 , 94);
            Color color4 = Color.FromArgb(144, 84 , 84);

            if(isFocused)
            {
                backgroundBrush = e.Cache.GetGradientBrush(e.Bounds, color1, color2, LinearGradientMode.ForwardDiagonal);
                foregroundBrush = Brushes.White;
            }
            else
            {
                backgroundBrush = e.Cache.GetGradientBrush(e.Bounds, color3, color4, LinearGradientMode.ForwardDiagonal);
                foregroundBrush = Brushes.Coral;
            }

            Rectangle rectangle = e.Bounds;

            rectangle.Inflate(1, 0);

            e.Cache.FillRectangle(backgroundBrush, rectangle);

            e.Appearance.DrawString(e.Cache, cardView.GetCardCaption(e.RowHandle),rectangle, foregroundBrush);

            e.Handled = true;
        }

        #endregion
    }
}